package me.teridax.jcash.gui.account;

import me.teridax.jcash.Main;
import me.teridax.jcash.banking.Profile;
import me.teridax.jcash.gui.deposit.DepositDialog;
import me.teridax.jcash.gui.takeoff.TakeoffDialog;
import me.teridax.jcash.gui.transfer.TransferDialog;

public class AccountController {

    private final AccountView view;

    public AccountController(Profile profile) {
        this.view = new AccountView();
        this.view.setProfile(profile);

        createListeners(profile);
    }

    private void createListeners(Profile profile) {
        this.view.getAccountSelection().addActionListener(e -> {
            var description = ((String) this.view.getAccountSelection().getSelectedItem());
            profile.setPrimaryAccount(description);
            this.view.setProfile(profile);
        });

        this.view.getLogout().addActionListener(e -> {
            Main.getInstance().logout();
            Main.getInstance().showLoginScreen();
        });

        this.view.getDeposit().addActionListener(e -> {
            new DepositDialog(profile.getPrimaryAccount(), () -> this.view.setProfile(profile));
        });

        this.view.getTakeoff().addActionListener(e -> {
            new TakeoffDialog(profile.getPrimaryAccount(), () -> this.view.setProfile(profile));
        });

        this.view.getTransfer().addActionListener(e -> {
            new TransferDialog(profile.getPrimaryAccount(), () -> this.view.setProfile(profile));
        });
    }

    public AccountView getView() {
        return view;
    }
}
